#ifndef WINDOW_H
#define WINDOW_H


#include <GL/glew.h>
#include <GLFW/glfw3.h>

#include "stars.h"
#include "texture.h"
#include "matma.h"
#include "timetextureprojectionprogram.h"

class Window{
 public:
    Window(const char*, int, int);
    void Initialize(int major_gl_version, int minor_gl_version);
    void Resize(int new_width, int new_height);
    void KeyEvent(int key, int scancode, int action, int mods);
    void Run(void);
    operator GLFWwindow*(){return window_;}
 private:
    int width_;
    int height_;
    const char* title_;
    GLFWwindow* window_;
    
    bool fullscreen_;

    Stars stars_;

    Texture star_texture_;

    TimeTextureProjectionProgram program_;

    Mat4 projection_matrix_;

    void InitModels();
    void InitTextures();
    void InitPrograms();

    void SetProjectionMatrix();

    void InitGlfwOrDie(int major_gl_version, int minor_gl_version);
    void InitGlewOrDie();
};


#endif // WINDOW_H

